**`Error: UPGRADE FAILED: StatefulSet.apps "xxx-mongodb-replicaset" is invalid: spec: Forbidden: updates to statefulset spec for fields other than 'replicas', 'template', and 'updateStrategy' are forbidden`**

We changed the default storage class in version 5.4.2, but puprously did not set it as breaking change. Do the following (this will have a short downtime (5min)

- `kubectl delete sts --cascade=false --namespace your-namespace xxx-mongodb-replicaset`
- restart the build immediatly

this won't change the storage class, but aftr that, it should continue as before.

If you want to actually change the replicaset storage class, you can kill one replicaset members at a time. This will recreate the member and depending on your replicaset, 
the replicaset member should resync. This works with mongodb-replicaset. you can use `catladder $ project-mongo-destroy-member <env>` (needs latest @panter/catladder)

---


**` Error: UPGRADE FAILED: "xxx-yyyyyy-review-zzzz" has no deployed releases`**

tl;dr: `helm delete --purge xxx-yyyyyy-review-zzzz`

This usually happens in helm2 if the last deployment partially failed. This can happen if helm waits for resources to be ready but one of your resources fails. Examples:

- your pods don't get into ready because they are missing a health-check
- you have post-install helm-hoook job that failed (migrations, seeds)
- one of your resources simply took too long to be ready

This results in a broken release which confuses helm. Solution is to delete the release:

`helm delete --purge xxx-yyyyyy-review-zzzz` (THIS CAN RESULT IN DATA-LOSS! Usually ok with review apps, but be careful with prod apps)

---

**`Error: UPGRADE FAILED: failed decoding reader into objects: unable to recognize "": no matches for kind "Deployment" in version "extensions/v1beta1"`**

tl;dr: if data loss acceptable (usually ok with review apps, but be careful with prod apps) `helm delete --purge xxx-yyyyyy-tttt-zzzz`

This can happen after a Kuberentes cluster upgrade when the currently deployed Helm release uses Kuberentes APIs that are no longer supported by the new Kuberentes version. For details see Helm v2 docs on [Deprecated Kubernetes APIs](https://v2.helm.sh/docs/kubernetes_apis/).

1. Ensure the chart you are using (usually [the-panter-chart](https://git.panter.ch/panter/helm-charts/tree/master/charts/the-panter-chart)), including it's dependencies, supports the APIs of the current Kubernetes version.
1. Use the [Helm mapkubeapis Plugin](https://github.com/hickeyma/helm-mapkubeapis) to in-place convert the last deployed release to supported Kuberentes APIs.
    1. Install the plugin: `helm plugin install https://github.com/hickeyma/helm-mapkubeapis`
    1. Ensure the latest Helm release version is the one currently in status `DEPLOYED`
       1. Check all releases with `helm history --max 20 <release-name>`
       1. Delete every later release **after** the one in state `DEPLOYED` with `kubectl --namespace kube-system delete configmap <release-name>.v<version>`
       1. Check that the latest releases is in state `DEPLOYED` with `helm history --max 20 <release-name>`
    1. Convert the latest release: `helm mapkubeapis --v2 <release-name>`
1. Retry the deployment job and it should work :-)


---

Please add more!